<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.repair_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="jobStatus" slot-scope="scope">
        <el-tag v-if="scope.row.jobStatus===0" type="info">待处理</el-tag>
        <el-tag v-if="scope.row.jobStatus===1" type="success">处理中</el-tag>
        <el-tag v-if="scope.row.jobStatus===2" >已处理</el-tag>
      </template>
      <template slot="residentialId" slot-scope="scope">{{scope.row.residentialName}}</template>
      <template slot="residentialIdForm" slot-scope="scope">
        <select-dialog-residential :disabled="true" :id="form.residentialId" :name="form.residentialName" :callback="selectCallback"></select-dialog-residential>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/estate/repair";
  import {mapGetters} from "vuex";
  import {validatePhone} from "../../util/validator";
  import SelectDialogResidential from "../../components/select-dialog/select-dialog-residential";

  export default {
    components: {SelectDialogResidential},
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          labelWidth: 120,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          addBtn:false,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "工单编号",
              prop: "jobNo",
              display:false,
              rules: [{
                required: true,
                message: "请输入工单编号",
                trigger: "blur"
              }]
            },
            {
              label: "上报人",
              prop: "reportor",
              hide: true,
              rules: [{
                required: true,
                message: "请输入上报人",
                trigger: "blur"
              }]
            },
            {
              label: "上报人电话",
              prop: "reportPhone",
              hide: true,
              rules: [{
                required: true,
                message: "请输入上报人电话",
              },{
                validator: validatePhone,
                trigger: "blur"
              }]
            },
            {
              label: "上报时间",
              prop: "reportTime",
              type: 'datetime',
              valueFormat: 'yyyy-MM-dd HH:mm:ss',
              hide: true,
              rules: [{
                required: true,
                message: "请输入上报时间",
                trigger: "blur"
              }]
            },
            {
              label: "处理人",
              prop: "handler",
              addDisplay:false,
              editDisplay:false,
              rules: [{
                required: true,
                message: "请输入处理人",
                trigger: "blur"
              }]
            },
            {
              label: "处理人电话",
              prop: "handlerPhone",
              hide: true,
              addDisplay:false,
              editDisplay:false,
              rules: [{
                required: true,
                message: "请输入处理人电话",
              },{
                validator: validatePhone,
                trigger: "blur"
              }]
            },
            {
              label: "工单状态",
              prop: "jobStatus",
              search: true,
              type:'select',
              addDisplay:false,
              slot: true,
              // dicUrl: "/api/blade-system/dict-biz/dictionary?code=job_status,
              // props: {
              //   label: "dictValue",
              //   value: "dictKey"
              // },
              dicData:[
                {
                  label:'待处理',
                  value:0
                },{
                  label:'处理中',
                  value:1
                },{
                  label:'已处理',
                  value:2
                }
              ],
              rules: [{
                required: true,
                message: "请选择工单状态",
                trigger: "blur"
              }]
            },
            {
              label: "所属小区",
              prop: "residentialId",
              type: "select",
              slot:true,
              formslot:true,
              // dicUrl: "/api/cyzh-community/residential/list?agencyId={{key}}&&size=9999",
              dicUrl: "/api/cyzh-community/residential/list?size=500",
              dicFormatter:(res)=>{
                return res.data.records;//返回字典的层级结构
              },
              // dicFlag: false,
              filterable: true,
              props: {
                label: "name",
                value: "id"
              },
              rules: [{
                required: false,
                message: "请选择所属小区",
                trigger: "blur"
              }]
            },
            {
              label: "机构路径",
              prop: "orgPosition",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入机构路径",
                trigger: "blur"
              }]
            },
            {
              label: "报修位置",
              prop: "reportPosition",
              rules: [{
                required: true,
                message: "请输入报修位置",
                trigger: "blur"
              }]
            },
            {
              label: "预约开始时间",
              prop: "beginTime",
              hide: true,
              type: 'datetime',
              valueFormat: 'yyyy-MM-dd HH:mm:ss',
              rules: [{
                required: false,
                message: "请输入预约开始时间",
                trigger: "blur"
              }]
            },
            {
              label: "预约结束时间",
              prop: "endTime",
              hide: true,
              type: 'datetime',
              valueFormat: 'yyyy-MM-dd HH:mm:ss',
              rules: [{
                required: false,
                message: "请输入预约结束时间",
                trigger: "blur"
              }]
            },
            {
              label: "是否已评价",
              prop: "estimateStatus",
              hide: true,
              display:false,
              type:'select',
              dicData:[
                {
                  label:'未评价',
                  value:0
                },{
                  label:'已评价',
                  value:1
                }
              ],
              rules: [{
                required: false,
                message: "请输入",
                trigger: "blur"
              }]
            },
            {
              label: "用户对处理结果的评论",
              prop: "comment",
              hide: true,
              rules: [{
                required: false,
                message: "请输入用户对处理结果的评论",
                trigger: "blur"
              }]
            },
            {
              label: "处理时间",
              prop: "handleTime",
              type: 'datetime',
              valueFormat: 'yyyy-MM-dd HH:mm:ss',
              hide: true,
              rules: [{
                required: false,
                message: "请输入处理时间",
                trigger: "blur"
              }]
            },
            {
              label: "小区名称",
              prop: "residentialName",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入小区名称",
                trigger: "blur"
              }]
            },
            {
              label: "物业系统id",
              prop: "oldId",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入物业系统id",
                trigger: "blur"
              }]
            },
            {
              label: "图片-多张图片用“，”切割",
              prop: "pic",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入图片-多张图片用“，”切割",
                trigger: "blur"
              }]
            },
            {
              label: "报修详情",
              prop: "reportDetail",
              hide: true,
              type: 'textarea',
              rules: [{
                required: false,
                message: "请输入报修详情",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      }
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.repair_add, false),
          viewBtn: this.vaildData(this.permission.repair_view, false),
          delBtn: this.vaildData(this.permission.repair_delete, false),
          editBtn: this.vaildData(this.permission.repair_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    created() {
      const tenantType = localStorage.getItem("tenantType");
      if (tenantType == 0){
        this.option.column[7].label = "所属小区"
      }else if (tenantType == 1){
        this.option.column[7].label = "所属区域"
      }
    },
    methods: {
      selectCallback(row){
        this.form.residentialId = row.id;
        this.form.residentialName = row.name;
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        loading = false;
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
